<?php
//  ------------------------------------------------------------------------ //
// 本模組由 ugm 製作
// 製作日期：2013-03-07
// $Id:$
// ------------------------------------------------------------------------- //
/*-----------引入檔案區--------------*/
include "header.php";
$xoopsOption['template_main'] = "ugm_beach_main.html";
include_once XOOPS_ROOT_PATH."/header.php";
#------ 權限判斷 -------------------------------------
if(!$isAdmin) redirect_header(XOOPS_URL,3,_NOPERM);
#-----------------------------------------------------
#取得kind資料庫
$tbl="ugm_beach_main";
#取得模組名稱
$DIRNAME=$xoopsModule->getVar('dirname');
#
/*-----------執行動作判斷區----------*/
$op=empty($_REQUEST['op'])?"":$_REQUEST['op'];
$sn=empty($_REQUEST['sn'])?"":intval($_REQUEST['sn']);

switch($op){
  //檢查資料庫是否已經有這個年、月
  case "CheckYearMonth":
    echo CheckYearMonth();
  exit;
  //新增、編輯
  case "op_insert":
    # 新增、編輯
    $sn=op_insert();
    //redirect_header($_SERVER['PHP_SELF']."?op=op_show_one&sn={$sn}",3,_BP_SUCCESS);
    redirect_header($_SERVER['PHP_SELF']."?sn={$sn}",3,_BP_SUCCESS);
  break;
  //輸入表格
  case "op_form":
    op_form($sn);
  break;
  //輸入詳細資料
  case "op_detail":
    op_detail($sn);
  break;
  //新增、編輯
  case "op_detail_update":
    # 新增、編輯
    op_detail_update();
    //redirect_header($_SERVER['PHP_SELF']."?op=op_show_one&sn={$sn}",3,_BP_SUCCESS);
    redirect_header($_SESSION['ugm_beach_return_url'],3,_BP_SUCCESS);
  break;

  //刪除資料
  case "op_delete":
  op_delete($sn);
  redirect_header("main.php",3,_BP_DEL_SUCCESS);
  break;
  //預設動作
  default:
    # ---- 目前網址 ----
    $_SESSION['ugm_beach_return_url']=getCurrentUrl();
    $op="op_list";
  	$main=op_list($sn);
    //$op="op_form";
    //op_form($sn);
  break;

}
/*-----------秀出結果區--------------*/
$xoopsTpl->assign( "toolbar" , toolbar_bootstrap($interface_menu)) ;
$xoopsTpl->assign( "bootstrap" , get_bootstrap()) ;
$xoopsTpl->assign( "jquery" , get_jquery(true)) ;
$xoopsTpl->assign( "isAdmin" , $isAdmin) ;
$xoopsTpl->assign( "op" , $op) ;
include_once XOOPS_ROOT_PATH.'/footer.php';

/*-----------function區--------------*/

###############################################################################
#  新增、編輯資料
###############################################################################
function op_insert(){
  global $xoopsDB,$xoopsUser,$tbl;
  //---- 過濾資料 -----------------------------------------*/
  $myts =& MyTextSanitizer::getInstance();
  //Array ( [year] => 2014 [month] => 11 [place] => 111 [contant] => 111 [op] => op_insert [sn] => )

  #年度
  $_POST['year']=intval($_POST['year']);
  #月份
  $_POST['month']=intval($_POST['month']);

  //die($_POST['year']."<br>".$_POST['month']."<br>".$_POST['sn']);

  #再次檢查年度與月份, 新增 且 查出已建立=>轉向
  if(!$_POST['sn'] and check_main_year_month($_POST['year'],$_POST['month'])) redirect_header($_SERVER['PHP_SELF'],3, "此年度、月份已經建立統計表！！");

  #建立日期
  $_POST['date']=$myts->addSlashes($_POST['date'])." 12:00:00";
  #使用者日期轉主機日期
  $_POST['date']=userTimeToServerTime(strtotime($_POST['date']));        # 使用者日期    => xoops主機日期
  #地點
  $_POST['place']=$myts->addSlashes($_POST['place']);
  #說明
  $_POST['contant']=$myts->addSlashes($_POST['contant']);
  #sn
  $mian_sn=intval($_POST['sn']);
  //-------------------------------------------------------*/
  if($mian_sn){
    #編輯
    $sql = "update ".$xoopsDB->prefix($tbl)." set
      `place`   = '{$_POST['place']}',
      `contant` = '{$_POST['contant']}'
      where sn='{$mian_sn}'";
      $xoopsDB->queryF($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());

  }else{
    #新增
    $sql = "insert into ".$xoopsDB->prefix($tbl)."
    (`year` , `month`,`place`,`contant`,`date`)
    values('{$_POST['year']}' , '{$_POST['month']}' ,'{$_POST['place']}','{$_POST['contant']}','{$_POST['date']}')";
    $xoopsDB->queryF($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
    //取得最後新增資料的流水編號
    $mian_sn = $xoopsDB->getInsertId();

    #建立統計表
    $sql = "select a.sn as prod_sn
            from      ".$xoopsDB->prefix("ugm_beach_prod")." as a
            left join ".$xoopsDB->prefix("ugm_beach_kind")." as b on a.kind_sn=b.sn
            left join ".$xoopsDB->prefix("ugm_beach_sort")." as c on a.sn=c.prod_sn and a.kind_sn=c.kind_sn
            where a.enable='1'
            order by b.sort,c.sort
    ";//die($sql);

    $result=$xoopsDB->query($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());

    while(list($prod_sn)=$xoopsDB->fetchRow($result)){
      $sql_1 = "insert into ".$xoopsDB->prefix("ugm_beach")."
                (`main_sn` , `prod_sn`)
                values('{$mian_sn}' , '{$prod_sn}')
      ";
      $xoopsDB->queryF($sql_1) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
    }

  }
  return $mian_sn;
}

###############################################################################
#  更新明細資料排名
###############################################################################
function op_detail_rank($main_sn=""){
  global $xoopsDB;
  $sql="select sn,amount
        from ".$xoopsDB->prefix("ugm_beach")."
        where main_sn='{$main_sn}'
        order by amount desc
  ";//die($sql);
  #----------------------------------------------------------------
  $result = $xoopsDB->query($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
  #-------------------------------------------------------------------------------------------
  $i=1;
  while($all=$xoopsDB->fetchArray($result)){
    //以下會產生這些變數： $sn,$amount
    foreach($all as $k=>$v){
      $$k=$v;
    }
    if($i == 1){
      $rank=1;
    }else{
      if($old_amount==$amount){
        $rank=$old_rank;
      }else{
        $rank=$i;
      }
    }

    $sql_1 = "update ".$xoopsDB->prefix("ugm_beach")." set
      `rank`   = '{$rank}'
      where sn='{$sn}'";
    $xoopsDB->queryF($sql_1) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
    $old_amount=$amount;
    $old_rank=$rank;
    $i++;
  }
}
###############################################################################
#  更新明細資料
###############################################################################
function op_detail_update(){
  global $xoopsDB;

  foreach($_POST['amount'] as $sn=>$amount){
    //---- 過濾資料 ----------------------------------*/
    $sn=intval($sn);
    $amount=intval($amount);
    #-------------------------------------------------
    $sql = "update ".$xoopsDB->prefix("ugm_beach")." set
      `amount`   = '{$amount}'
      where sn='{$sn}'";//die($sql);
    $xoopsDB->queryF($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
  }
  #排名
  $_POST['sn']=intval($_POST['sn']);
  op_detail_rank($_POST['sn']);
}
###############################################################################
#  編輯表單
###############################################################################
function op_form($sn=""){
  global $xoopsDB,$xoopsUser,$xoopsTpl,$tbl;
  //----------------------------------*/
  //抓取預設值
  if(!empty($sn)){
    $DBV=get_ugm_module_tbl($sn,$tbl);
  }else{
    $DBV=array();
  }
  //預設值設定
  //設定「sn」欄位預設值
  $sn=(!isset($DBV['sn']))?"":$DBV['sn'];
  $xoopsTpl->assign('sn',$sn);
  //設定「year」欄位預設值
  $year=(!isset($DBV['year']))?"":$DBV['year'];
  $xoopsTpl->assign('year',$year);
  //設定「month」欄位預設值
  $month=(!isset($DBV['month']))?"":$DBV['month'];
  $xoopsTpl->assign('month',$month);
  //設定「date」欄位預設值
  $date=(!isset($DBV['date']))?strtotime("now"):$DBV['date'];
  #主機時間轉為使用者時間
  $date=date("Y-m-d" , xoops_getUserTimestamp($date));
  $xoopsTpl->assign('date',$date);
  //設定「contant」欄位預設值
  $contant=(!isset($DBV['contant']))?"":$DBV['contant'];
  $xoopsTpl->assign('contant',$contant);
  //設定「place」欄位預設值
  $place=(!isset($DBV['place']))?"":$DBV['place'];
  $xoopsTpl->assign('place',$place);
}
###############################################################################
#  編輯詳細資料
###############################################################################
function op_detail($sn=""){
  global $xoopsDB,$xoopsUser,$xoopsTpl,$tbl;
  //----------------------------------*/
  //抓取主檔預設值
  $DBV=get_ugm_module_tbl($sn,$tbl);
  if(!$DBV) redirect_header($_SERVER['PHP_SELF'],3,"資料錯誤！！");
  //預設值設定
  $date=date("Y-m-d" , xoops_getUserTimestamp($DBV['date']));
  $head=array(
    "main_sn"=>$sn,"year"=>$DBV['year'],"month"=>$DBV['month'],"date"=>$date,"contant"=>$DBV['contant'],"place"=>$DBV['place']
    );
  $xoopsTpl->assign('head',$head);
  #-----------------------------------------------------------------
  $sql="select a.sn,a.main_sn,a.prod_sn,a.amount,a.rank,b.title as prod_title,c.title as kind_title
        from      ".$xoopsDB->prefix("ugm_beach")."      as a
        left join ".$xoopsDB->prefix("ugm_beach_prod")." as b on a.prod_sn=b.sn
        left join ".$xoopsDB->prefix("ugm_beach_kind")." as c on b.kind_sn=c.sn
        left join ".$xoopsDB->prefix("ugm_beach_sort")." as d on a.prod_sn=d.prod_sn and b.kind_sn=d.kind_sn
        where a.main_sn='{$sn}'
        order by c.sort,d.sort
  ";//die($sql);
  #----------------------------------------------------------------
  $result = $xoopsDB->query($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
  #-------------------------------------------------------------------------------------------
  while($all=$xoopsDB->fetchArray($result)){
    //以下會產生這些變數： $sn,$main_sn,$prod_sn,$amount,$prod_title,$kind_title
    foreach($all as $k=>$v){
      $$k=$v;
    }
    $amount=$amount?$amount:"";
    $list[]=array('sn' => $sn,  'main_sn' => $main_sn, 'prod_sn' => $prod_sn,'amount'=>$amount,'rank'=>$rank,'prod_title'=>$prod_title,'kind_title'=>$kind_title);
  }
  //print_r($list);
  //die();
  $xoopsTpl->assign('list',$list);
}

###############################################################################
#  年度下拉選單
###############################################################################
function get_year_select($year_chk=""){
  global $xoopsDB,$xoopsModule,$xoopsTpl,$tbl;
  $sql=" select max(`year`),min(`year`)
          from      ".$xoopsDB->prefix($tbl)."
  ";die($sql);
}
###############################################################################
#  列出所有統計表的資料
###############################################################################
function op_list($sn=""){
	global $xoopsDB,$xoopsModule,$xoopsTpl,$tbl;
  #--------and_key---------------------------------------

  $year_in=intval($_REQUEST['year']);
  if(!$year_in){
    #取得最大年度
    $year_in=get_ugm_baech_main_max_year();
  }

  #---------所有年度的option---------------------------------------------------
  $xoopsTpl->assign('year_month_option',get_year_month_option("year",$year_in));
  #---------------------------------------------------------------------------


  #------------------------------------------------------
  #類別只有一階,且直接編輯，拖曳排序
	$sql = "select a.*
          from      ".$xoopsDB->prefix($tbl)."             as a
          where a.year='{$year_in}'
          order by year desc,month desc
  ";//die($sql);
  //使用分頁物件
  //getPageBar($原sql語法, 每頁顯示幾筆資料, 最多顯示幾個頁數選項);
  $count=20;
  $PageBar=getPageBar($sql,$count,10);
  $bar=$PageBar['bar'];
  $sql=$PageBar['sql'];
  $total=$PageBar['total'];
  #----------------------------------------------------------------
	$result = $xoopsDB->query($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
  # 是否出現分頁
  $bar=($total>$count)?$bar:"";
  $xoopsTpl->assign('bar',$bar);
  #-------------------------------------------------------------------------------------------
	while($all=$xoopsDB->fetchArray($result)){
	  //以下會產生這些變數： $sn ,  $year , $month  ,$place,$contant,$date
    foreach($all as $k=>$v){
      $$k=$v;
    }
    #轉換時間(主機=>使用者)
    $date=date("Y-m-d" , xoops_getUserTimestamp($date));
    $list[]=array('sn' => $sn,  'year' => $year, 'month' => $month,'place'=>$place,'contant'=> $contant,'date'=>$date);
	}
  $xoopsTpl->assign('list',$list);
}
###############################################################################
#  get_kind_sn_option($kind_sn)
###############################################################################
function get_kind_sn_option($check_sn=""){
  global $xoopsDB,$xoopsTpl;
  $sql="select sn,title
        from ".$xoopsDB->prefix("ugm_beach_kind")."
        where enable='1'
        order by sort
        ";
  $result=$xoopsDB->query($sql);//die($sql);
  while(list($sn,$title)=$xoopsDB->fetchRow($result)){
    $selected=($check_sn==$sn)?" selected":"";
    #傳至smarty
    $option[]=array(
      "title"   =>$title,
      "sn"   =>$sn,
      "selected"=>$selected
    );
    #傳至php
    //$option.="<option value='{$sn}' {$selected}>{$title}</option>";
  }
  $xoopsTpl->assign( "kind_sn_option" , $option) ;
  //return $option;
}
###############################################################################
#  編輯表單
###############################################################################
function op_show_one($sn=""){
  global $xoopsDB,$xoopsUser,$xoopsTpl,$tbl;
  //抓取預設值
  $sql = "select a.title,a.enable,b.title as kind_title
          from      ".$xoopsDB->prefix($tbl)."             as a
          left join ".$xoopsDB->prefix("ugm_beach_kind")." as b on a.kind_sn = b.sn
          where a.sn='{$sn}'";
  $DBV=get_ugm_module_sql($sql);
  #ugm這裡要轉向
  if(!$DBV)return;
  $xoopsTpl->assign('DBV',$DBV);

  $xoopsTpl->assign('return_url',$_SESSION['ugm_beach_return_url']);
  /*
  $result = $xoopsDB->query($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
  list($title,$enable,$kind_title)=$xoopsDB->fetchRow($result);
  $enable=$enable?"啟用":"停用";
  #ugm這裡要轉向
  //if(!$title)return;
  $xoopsTpl->assign('title',$title);
  $xoopsTpl->assign('enable',$enable);
  $xoopsTpl->assign('kind_title',$kind_title);
  */
}
#####################################################################################
#  get_ugm_module_max_sort_1
#####################################################################################
function get_ugm_module_max_sort_1($chk_sn=""){
  global $xoopsDB;
  $sql = "select max(`sort`)
          from ".$xoopsDB->prefix("ugm_beach_sort")."
          where kind_sn='{$chk_sn}'";//die($sql );
  $result = $xoopsDB->query($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
  list($sort)=$xoopsDB->fetchRow($result);
  return ++$sort;
}
###############################################################################
#  自動更新排序
###############################################################################
function op_update_sort(){
  global $xoopsDB,$tbl;
  $sort=1;
  $kind_sn=intval($_GET['kind_sn']);
  #刪除排序(類別全部的排序全刪)
  $sql="delete from ".$xoopsDB->prefix("ugm_beach_sort")."
        where `kind_sn`='{$kind_sn}'";
  $xoopsDB->queryF($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
  foreach ($_POST['tr'] as $prod_sn) {
    #新增排序
    $sql = "insert into ".$xoopsDB->prefix("ugm_beach_sort")."
    (`prod_sn` , `kind_sn` , `sort`)
    values
    ('{$prod_sn}' , '{$kind_sn}' , '{$sort}')";//die($sql);
    $xoopsDB->queryF($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
    $sort++;
  }
  //return print_r($_POST['tr']);
  return "Save Sort OK! (".date("Y-m-d H:i:s").")";
}
###############################################################################
#  自動更新排序
###############################################################################
function op_update_sort_one($prod_sn="",$kind_sn="",$sort=0){
  global $xoopsDB;
  if(!$prod_sn or !$kind_sn)return;
  #刪除排序
  $sql="delete from ".$xoopsDB->prefix("ugm_beach_sort")."
        where `prod_sn`='{$prod_sn}' and `kind_sn`='{$kind_sn}'";
  $xoopsDB->queryF($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
  #新增排序
  $sql = "insert into ".$xoopsDB->prefix("ugm_beach_sort")."
  (`prod_sn` , `kind_sn` , `sort`)
  values
  ('{$prod_sn}' , '{$kind_sn}' , '{$sort}')";//die($sql);
  $xoopsDB->queryF($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
  return;
}
###############################################################################
#  刪除資料
###############################################################################
function op_delete($sn=""){
	global $xoopsDB,$tbl;
	if(empty($sn))redirect_header($_SERVER['PHP_SELF'],3, _BP_DEL_ERROR);
  # 刪除明細檔
  $sql = "delete from ".$xoopsDB->prefix("ugm_beach")."
          where main_sn='{$sn}'";//die($sql);
  $xoopsDB->queryF($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
  # 刪除主檔
	$sql = "delete from ".$xoopsDB->prefix($tbl)."
          where sn='{$sn}'";//die($sql);
	$xoopsDB->queryF($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
}

###############################################################################
# check_main_year_month
# 檢查統計表之年月是否已經建立，已建立(true)、未建立(false)
###############################################################################
function check_main_year_month($year="",$month=""){
  global $xoopsDB,$tbl;
  $sql = "select count(`sn`)
          from      ".$xoopsDB->prefix($tbl)."
          where year='{$year}' and month='{$month}'
         ";//die($sql);
  $result = $xoopsDB->query($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
  list($count)=$xoopsDB->fetchRow($result);
  if($count)return true;
  return false;
}
###############################################################################
# ajax
#
###############################################################################
function CheckYearMonth(){
    //http://www.cnblogs.com/whatadiors/p/3923579.html
    $arrayToJs=array();
    $_REQUEST['year']=intval($_REQUEST['year']);
    $_REQUEST['month']=intval($_REQUEST['month']);
    $check=check_main_year_month($_REQUEST['year'],$_REQUEST['month']);
    if(!$_REQUEST['year'] or !$_REQUEST['month'] or $check ) {
        # 驗證失敗
        $arrayToJs[1]=false;
    }else{
        # 驗證成功
        $arrayToJs[1]=true;
    }
    $arrayToJs[0]=$_REQUEST['fieldId'];
    return json_encode($arrayToJs);
}
?>