<?php
function xoops_module_install_ugm_beach(&$module) {
  global $xoopsDB;
  #類別
  $kind_sort=1;
  $kind=array(
    "沙灘與休閒活動"=>array("氣球/ 球","飲料塑膠杯","飲料保麗龍杯","飲料玻璃瓶","飲料塑膠罐","瓶蓋","吸管/攪拌器","鋁箔包（利樂包）","鐵鋁罐","鞋子/鞋墊","文具用品","玩具","筷子/湯匙/刀/叉","食物容器（碗、盤）","鞭炮/沖天炮","塑膠袋","塑膠用品","花盆","牙刷","瓦斯鋼瓶","紙類","橡皮筋","布","化妝用品","藥品","其它"),
    "海上活動與船隻"=>array("裝魚餌的容器","浮標/螢光棒/浮球","捕蟹/龍蝦/魚籠","條板箱","魚線/魚鉤","魚餌","漁業用保麗龍","魚網","裝油/潤滑劑的瓶子","塑膠布/防水衣","繩子/綑扎帶","漁業用鐵絲"),
    "抽煙"=>array("煙蒂","打火機","濾嘴","煙盒"),
    "醫療/個人衛生用品"=>array("保險套","尿布","針筒","衛生棉條","藥用玻璃瓶","藥用塑膠瓶"),
    "傾倒廢棄物"=>array("家電用品","電池","建築材料","輪胎","廢五金","泡棉","安全帽","塑膠板","橡膠","燈泡/燈管","清潔/漂白劑瓶","(其他)")
  );
  foreach ($kind  as $kind_title => $prod_arr){
    #寫入類別
    $sql="insert into ".$xoopsDB->prefix("ugm_beach_kind")." ( `title`, `sort`) values('{$kind_title}', '{$kind_sort}')";
    $xoopsDB->queryF($sql);
    //取得最後新增資料的流水編號
    $kind_sn = $xoopsDB->getInsertId();

    #類別排序++
    $kind_sort++;

    #廢棄物排序，由1開始
    $prod_sort=1;

    foreach ($prod_arr  as  $prod_title){
      #寫入廢棄物
      $sql="insert into ".$xoopsDB->prefix("ugm_beach_prod")." ( `title`, `kind_sn`) values('{$prod_title}', '{$kind_sn}')";
      $xoopsDB->queryF($sql);

      //取得最後新增資料的流水編號
      $prod_sn = $xoopsDB->getInsertId();

      #寫入排序
      $sql="insert into ".$xoopsDB->prefix("ugm_beach_sort")." ( `kind_sn`, `prod_sn`,`sort`) values('{$kind_sn}', '{$prod_sn}','{$prod_sort}')";
      $xoopsDB->queryF($sql);//die($sql);

      $prod_sort++;
    }
  }

  return true;
}

//建立目錄
function mk_dir($dir=""){
  //若無目錄名稱秀出警告訊息
  if(empty($dir))return;
  //若目錄不存在的話建立目錄
  if (!is_dir($dir)) {
    umask(000);
    //若建立失敗秀出警告訊息
    mkdir($dir, 0777);
  }
}
?>
