CREATE TABLE ugm_beach_sort (
  `kind_sn` smallint(5) unsigned NOT NULL,
  `prod_sn` smallint(5) unsigned NOT NULL,
  `sort` smallint(5) unsigned NOT NULL
);


CREATE TABLE ugm_beach_prod (
  `sn` smallint(5) unsigned NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '''' comment ' 物品名稱',
  `kind_sn` smallint(5) unsigned NOT NULL comment '類別',
  `enable` enum('0','1') NOT NULL default '1' comment '啟用',
  PRIMARY KEY  (`sn`)
);


CREATE TABLE ugm_beach_kind (
  `sn` smallint(5) unsigned NOT NULL auto_increment comment 'sn',
  `ofsn` smallint(5) unsigned NOT NULL comment '父類別',
  `title` varchar(255) NOT NULL comment '類別名稱',
  `enable` enum('1','0') NOT NULL default '1' comment '狀態',
  `sort` smallint(5) unsigned NOT NULL comment '排序',
  PRIMARY KEY  (`sn`)
);


CREATE TABLE ugm_beach_main (
  `sn` int(10) unsigned NOT NULL auto_increment,
  `date` int(10) unsigned NOT NULL comment '日期',
  `year` smallint(5) unsigned NOT NULL comment '年度',
  `month` tinyint(3) unsigned NOT NULL comment '月份',
  `contant` text NOT NULL comment '內容',
  `place` varchar(255) NOT NULL comment '地點',
  PRIMARY KEY  (`sn`)
);


CREATE TABLE ugm_beach (
  `sn` int(10) unsigned NOT NULL auto_increment,
  `main_sn` int(10) unsigned NOT NULL,
  `prod_sn` smallint(5) unsigned NOT NULL,
  `amount` smallint(5) unsigned NOT NULL,
  `rank` smallint(5) unsigned NOT NULL,
  PRIMARY KEY  (`sn`)
);


