<?php
###############################################################################
#  取得目前網址
#
###############################################################################
if(!function_exists("getCurrentUrl1")){
function getCurrentUrl1(){
  global $_SERVER;
  /**
   * Filter php_self to avoid a security vulnerability.
   */
  $php_request_uri = htmlentities(substr($_SERVER['REQUEST_URI'], 0, strcspn($_SERVER['REQUEST_URI'], "\n\r")), ENT_QUOTES);
  if(isset($_SERVER['HTTPS']) && strtolower($_SERVER['HTTPS']) == 'on'){
    $protocol = 'https://';
  }else{
    $protocol = 'http://';
  }
  $host = $_SERVER['HTTP_HOST'];
  if($_SERVER['SERVER_PORT'] != '' &&
    (($protocol == 'http://' && $_SERVER['SERVER_PORT'] != '80') ||
    ($protocol == 'https://' && $_SERVER['SERVER_PORT'] != '443'))){
     $port = ':' . $_SERVER['SERVER_PORT'];
  }else{
    $port = '';
  }

  return $protocol . $host . $port . $php_request_uri;
}
}
###############################################################################
#  取得目前網址
#
###############################################################################
if(!function_exists("getCurrentUrl")){
function getCurrentUrl(){
  global $_SERVER;
  $protocol = strpos(strtolower($_SERVER['SERVER_PROTOCOL']),'https')=== FALSE ? 'http' : 'https';
  $host     = $_SERVER['HTTP_HOST'];
  $script   = $_SERVER['SCRIPT_NAME'];
  $params   = $_SERVER['QUERY_STRING']?'?' . $_SERVER['QUERY_STRING']:"";

  $currentUrl = $protocol . '://' . $host . $script .  $params;
  //die( $currentUrl);
  return $currentUrl;;
}
}

################################################################################
#   檢查某資料表的某欄位是否有資料(資料表,key欄位名,key值)
#   1. 有資料 ->  true
#   2. 無資料 ->  false
#
################################################################################
if(!function_exists("check_tbl_col_sn")){
function check_tbl_col_sn($tbl="",$col="",$sn=""){
  global $xoopsDB;
  if(empty($tbl) or empty($col) or empty($sn)) return false;
  $sql = "select count(*) from ".$xoopsDB->prefix($tbl)."
          where `{$col}`='{$sn}'";
  $result = $xoopsDB->query($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
  list($count)=$xoopsDB->fetchRow($result);
  if($count)return true;
  return false;
}
}
#####################################################################################
#  自動取得(排序欄位,資料表)的最新排序
#  get_ugm_module_max_sort($col,$tbl)
#  (排序欄位,資料表)#
#####################################################################################
if(!function_exists("get_ugm_module_max_sort")){
function get_ugm_module_max_sort($col,$tbl){
  global $xoopsDB;
  if(empty($col) or empty($tbl))return;
  $sql = "select max($col) from ".$xoopsDB->prefix($tbl);
  $result = $xoopsDB->query($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
  list($sort)=$xoopsDB->fetchRow($result);
  return ++$sort;
}
}
####################################################################################
#  以流水號取得某筆分類資料
#  get_ugm_module_tbs(流水號,資料表)
####################################################################################
if(!function_exists("get_ugm_module_tbl")){
function get_ugm_module_tbl($sn="",$tbl=""){
  global $xoopsDB;
  if(empty($sn) or empty($tbl))return;
  $sql = "select * from ".$xoopsDB->prefix($tbl)." where sn='{$sn}'";
  $result = $xoopsDB->query($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
  $data=$xoopsDB->fetchArray($result);
  return $data;
}
}

####################################################################################
#  以$sql取得某筆分類資料
#  get_ugm_module_tbs($sql)
####################################################################################
if(!function_exists("get_ugm_module_sql")){
function get_ugm_module_sql($sql=""){
  global $xoopsDB;
  if(empty($sql)) return;
  //$sql = "select * from ".$xoopsDB->prefix($tbl)." where sn='{$sn}'";
  $result = $xoopsDB->query($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
  $data=$xoopsDB->fetchArray($result);
  return $data;
}
}
################################################################################
#   燈箱打包碼(內容,標題)
################################################################################
if(!function_exists("show_lytebox_html")){
function show_lytebox_html($content,$title){
  global $xoopsModule;
  $DIRNAME=$xoopsModule->getVar('dirname');
  $jquery=get_jquery();
  $main="
    <!DOCTYPE html>
    <html lang='"._LANGCODE."'>
      <head>
        <meta charset='"._CHARSET."'>
        <title></title>
        <meta name='viewport' content='width=device-width, initial-scale=1.0'>
        <link rel='stylesheet' type='text/css' media='screen' href='".XOOPS_URL."/modules/tadtools/bootstrap/css/bootstrap.css' />
        <link rel='stylesheet' type='text/css' media='screen' href='".XOOPS_URL."/modules/tadtools/bootstrap/css/bootstrap-responsive.css' />
        <link rel='stylesheet' type='text/css' media='screen' href='".XOOPS_URL."/modules/tadtools/css/xoops_adm.css' />
        <link rel='stylesheet' type='text/css' media='screen' href='".XOOPS_URL."/modules/{$DIRNAME}/css/module.css' />
      </head>
      <body>
        <div class='container'>
          <h1>{$title}</h1>
          $content
        </div>
        $jquery
        <script src='".XOOPS_URL."/modules/tadtools/bootstrap/js/bootstrap.min.js'></script>
      </body>
    </html>
    ";
  return $main;
}
}
?>
