<?php
#============================================================+
# File name   : xls_month.php
# Begin       : 匯出單月廢棄物統計表
#
#
#============================================================+
/*-----------引入檔案區--------------*/
include "header.php";
include_once XOOPS_ROOT_PATH."/header.php";
#------ 權限判斷 -------------------------------------
if(!$isAdmin) redirect_header(XOOPS_URL,3,_NOPERM);
#-----------------------------------------------------
/*-----------執行動作判斷區----------*/
$sn=intval($_REQUEST['sn']);
if(!$sn) redirect_header("index.php",3, "查無資料");
# 取得主檔
$DBV=get_ugm_module_tbl($sn,"ugm_beach_main");
# 檢查是否有資料
if(!$DBV) redirect_header("main.php",3,"資料錯誤！！");
# ---- 日期轉為使用者日期格式- -------------------
$DBV['date']=date("Y-m-d" , xoops_getUserTimestamp($DBV['date']));
$xoopsTpl->assign( "DBV" , $DBV) ;

# ---- 取得印表人uid ----------------------------------------------------------
$user_uid=$xoopsUser->getVar('uid');
# ---- 取得姓名 ---------------------------------------------------------------
$user_name=$xoopsUser->getVar('name')?$xoopsUser->getVar('name'):$xoopsUser->getVar('uname');
# ------------------------------------------------------------------------------

#----- 明細檔 ----------------------------------------------------
$sql="select a.sn,a.main_sn,a.prod_sn,a.amount,a.rank,b.title as prod_title,c.title as kind_title
      from      ".$xoopsDB->prefix("ugm_beach")."      as a
      left join ".$xoopsDB->prefix("ugm_beach_prod")." as b on a.prod_sn=b.sn
      left join ".$xoopsDB->prefix("ugm_beach_kind")." as c on b.kind_sn=c.sn
      left join ".$xoopsDB->prefix("ugm_beach_sort")." as d on a.prod_sn=d.prod_sn and b.kind_sn=d.kind_sn
      where a.main_sn='{$sn}'
      order by c.sort,d.sort
";//die($sql);
#----------------------------------------------------------------
$result = $xoopsDB->query($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
# 檢查是否有資料(這裡主檔已檢查)
//if(!$xoopsDB->getRowsNum($result))redirect_header("main.php",3, "查無資料");
#-------------------------------------------------------------------------------------------
$excel_title="廢棄物月統計表";
# ------------------------------------------------------------------------------


# excelphp開始
#引入 PHPExcel 物件庫  modules\tadtools\PHPExcel
require_once XOOPS_ROOT_PATH.'/modules/tadtools/PHPExcel.php';
#引入 PHPExcel_IOFactory 物件庫
require_once XOOPS_ROOT_PATH.'/modules/tadtools/PHPExcel/IOFactory.php';

//设置最大执行时间
set_time_limit(0);
//设置最大内存为128M
@ini_set('memory_limit', '128M');


$cacheMethod = PHPExcel_CachedObjectStorageFactory::cache_to_phpTemp;
$cacheSettings = array ('cacheTime' => 300);
PHPExcel_Settings::setCacheStorageMethod ( $cacheMethod, $cacheSettings );


# -------------   實體化Excel  ----------------
$objPHPExcel = new PHPExcel();
/*
// 設定屬性
$objPHPExcel->getProperties()->setCreator("PHP")
->setLastModifiedBy("PHP")
->setTitle("Title")
->setSubject("Subject")
->setDescription("Description")
->setKeywords("Keywords")
->setCategory("Category");

//設定操作中的工作表
$objPHPExcel->setActiveSheetIndex(0);
*/

# ----- 紙張設定 PHPExcel\Worksheet\PageSetup.php -----------------
# A4纸大小(紙張)
$objPHPExcel->getActiveSheet()->getPageSetup()->setPaperSize(PHPExcel_Worksheet_PageSetup:: PAPERSIZE_A4);
# 方向(直)
$objPHPExcel->getActiveSheet()->getPageSetup()->setOrientation(PHPExcel_Worksheet_PageSetup:: ORIENTATION_DEFAULT);
#方向(橫)
#$objPHPExcel->getActiveSheet()->getPageSetup()->setOrientation(PHPExcel_Worksheet_PageSetup:: ORIENTATION_LANDSCAPE);
#重覆標題列
$objPHPExcel->getActiveSheet()->getPageSetup()->setRowsToRepeatAtTop(array(1,3));

# ---- 邊界設定 PHPExcel\Worksheet\PageMargins.php -----------------
$objPHPExcel->getActiveSheet()->getPageMargins()->setTop(0.5);    # ---- 上邊界 預設 0.75----
$objPHPExcel->getActiveSheet()->getPageMargins()->setBottom(0.5); # ---- 下邊界 預設 0.75----
$objPHPExcel->getActiveSheet()->getPageMargins()->setLeft(0.4);   # ---- 左邊界 預設 0.7----
$objPHPExcel->getActiveSheet()->getPageMargins()->setRight(0.4);  # ---- 右邊界 預設 0.7----
$objPHPExcel->getActiveSheet()->getPageMargins()->setHeader(0.2); # ---- 頁頁   預設 0.3----
$objPHPExcel->getActiveSheet()->getPageMargins()->setFooter(0.2); # ---- 頁尾   預設 0.3----

# 設置列的高度
$objPHPExcel->getActiveSheet()->getDefaultRowDimension()->setRowHeight(22);
# 設置單元格寬度(全部)
//$objPHPExcel->getActiveSheet()->getDefaultColumnDimension()->setWidth(10);

# 設置欄的寬度
$objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth(34);   # ---- 類別 ----
$objPHPExcel->getActiveSheet()->getColumnDimension('B')->setWidth(30);  # ---- 名稱 ----
$objPHPExcel->getActiveSheet()->getColumnDimension('C')->setWidth(15);  # ---- 數量 ----
$objPHPExcel->getActiveSheet()->getColumnDimension('D')->setWidth(15);  # ---- 排名 ----

# 設置當前工作表的名稱
$objPHPExcel->getActiveSheet()->setTitle($DBV['year']."-".$DBV['month']);
# 垂直置中
$objPHPExcel->getActiveSheet()->getStyle()->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);
/*
  //Set alignments 設置對齊
                $objPHPExcel->getActiveSheet()->getStyle('D11')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
                $objPHPExcel->getActiveSheet()->getStyle('A18')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_JUSTIFY);
                $objPHPExcel->getActiveSheet()->getStyle('A18')->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);
                $objPHPExcel->getActiveSheet()->getStyle('A3')->getAlignment()->setWrapText(true);


&C:置中 &R:靠右

 &P of &N


//设置某单元格为页尾
$objPHPExcel->getActiveSheet()->setBreak( 'A' . $i, PHPExcel_Worksheet::BREAK_ROW );


# ----------      設定頁首 -----------------------------------
 &L ->左區塊    &C ->中區塊   &R->右區塊
 &D ->日期      &T ->時間
 &P ->頁數      &N ->總頁數
 &font size
 &B ->粗體
# ------------------------------------------------------------*/
$objPHPExcel->getActiveSheet()->getHeaderFooter()->setOddHeader( "&L&B"."&C&B 廢棄物月統計表 ". "&R &D   Page &P of &N");
//$objPHPExcel->getActiveSheet()->getHeaderFooter()->setOddFooter( '&L&D  &T' . '&R' ); 頁尾
# ---- 註：單元格「欄」是以0開始的，「列」是以1開始的
$row=1;         #「列」
# 設定儲存格為文字形態
$type = PHPExcel_Cell_DataType::TYPE_STRING;

# ---- 設置主檔第一行的標題 ----
# ---- 格式化 ---------------------------------------------------------------
# ---- 框線
$objPHPExcel->getActiveSheet()->getStyle("A{$row}:D{$row}")->getBorders()->getAllborders()->setBorderStyle(PHPExcel_Style_Border::BORDER_HAIR);
# ---- 粗體
$objPHPExcel->getActiveSheet()->getStyle("A{$row}:D{$row}")->getFont()->setBold(true);//設置第一行內容加粗
# ---- 垂直置中對齊
$objPHPExcel->getActiveSheet()->getStyle("A{$row}:D{$row}")->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);
# ---- 水平置中對齊
#$objPHPExcel->getActiveSheet()->getStyle("A{$row}:H{$row}")->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
//合併儲存格
$objPHPExcel->getActiveSheet()->mergeCells("A{$row}:D{$row}");
$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $row, "年度：".$DBV['year']."    月份：".$DBV['month']."    日期：".$DBV['date']."    地點：".$DBV['place']);
$row++;
# ---- 設置主檔第二行的標題 ----
# ---- 框線
$objPHPExcel->getActiveSheet()->getStyle("A{$row}:D{$row}")->getBorders()->getAllborders()->setBorderStyle(PHPExcel_Style_Border::BORDER_HAIR);
# ---- 粗體
$objPHPExcel->getActiveSheet()->getStyle("A{$row}:D{$row}")->getFont()->setBold(true);//設置第一行內容加粗
# ---- 垂直置中對齊
$objPHPExcel->getActiveSheet()->getStyle("A{$row}:D{$row}")->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);
$objPHPExcel->getActiveSheet()->mergeCells("A{$row}:D{$row}");
$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $row, "說明：".$DBV['contant']);
$row++;

# ---- 以下為身體部份 --------

# ---- 設置身體的標題 ----
# ---- 框線
$objPHPExcel->getActiveSheet()->getStyle("A{$row}:D{$row}")->getBorders()->getAllborders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);
# ---- 粗體
$objPHPExcel->getActiveSheet()->getStyle("A{$row}:D{$row}")->getFont()->setBold(true);//設置第一行內容加粗
# ---- 垂直置中對齊
$objPHPExcel->getActiveSheet()->getStyle("A{$row}:D{$row}")->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);
# ---- 水平置中對齊
$objPHPExcel->getActiveSheet()->getStyle("A{$row}:D{$row}")->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

$col=0;         #「欄」
$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col, $row, "類別");
$col++;
$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col, $row, "廢棄物名稱");
$col++;
$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col, $row, "數量");
$col++;
$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col, $row, "排名");
$row++;
# ---- 設置身體的循環開始 ----
# ---------------------------------------------------------------------------
while($all=$xoopsDB->fetchArray($result)){
  //以下會產生這些變數： $sn,$main_sn,$prod_sn,$amount,$rank,$prod_title,$kind_title
  foreach($all as $k=>$v){
    $$k=$v;
  }
  # ---- 格式化 ---------------------------------------------------------------
  # 框線
  $objPHPExcel->getActiveSheet()->getStyle("A{$row}:D{$row}")->getBorders()->getAllborders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);
  # 垂直置中對齊
  $objPHPExcel->getActiveSheet()->getStyle("A{$row}:D{$row}")->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);
  # 水平置中對齊
  $objPHPExcel->getActiveSheet()->getStyle("A{$row}:D{$row}")->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
  #-----------------------------------------------------------------------------
  $col=0;         #「欄」
  $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col, $row, $kind_title);        # 類別
  $col++;
  $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col, $row, $prod_title);        # 廢棄物名稱
  $col++;
  $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col, $row, $amount);            # 數量
  $col++;
  $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col, $row, $rank);              # 排名
  $row++;
}

# ---- 頁尾 -------------------------------------
$objPHPExcel->getActiveSheet()->setBreak( 'A' . $row, PHPExcel_Worksheet::BREAK_ROW );
# -------------------------------------------


# ------------  內容end  -------------------------

# ---- 提示下载文件 excel 2003 .xls
header('Content-Type: application/vnd.ms-excel');
header("Content-Disposition: attachment;filename={$excel_title}_{$DBV['year']}_{$DBV['month']}.xls");
header('Cache-Control: max-age=0');
$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
$objWriter->setPreCalculateFormulas(false);
$objWriter->save('php://output');
exit;
# -------------------------------------------------------------------------------
?>